

import java.sql.*;

public class t0054
{
   static public void main(String args[])
      throws SQLException, java.lang.ClassNotFoundException 
   {
      System.out.println("Starting test t0054-  test the warning chain methods.");
      
      boolean passed       = true;
      Connection  cx       = Common.getConnection();
      
      System.out.println("First check the methods are implemented.");
      try 
      {
         System.out.print("Connection: ");
         SQLWarning w = cx.getWarnings();
         if (w != null) 
         {
             System.out.println("Got Warning "+w.getMessage());
             passed = false;
         }
         cx.clearWarnings();
         System.out.println((passed ? "Passed" : "Failed"));

         System.out.print("Statement: ");
         Statement stmt = cx.createStatement();
         w = stmt.getWarnings();
         if (w != null) 
         {
             System.out.println("Got Warning "+w.getMessage());
             passed = false;
         }
         stmt.clearWarnings();
         System.out.println((passed ? "Passed" : "Failed"));

         try 
         {
             stmt.executeUpdate("drop table t0054_1");
         } 
         catch (SQLException sqlEx) 
         {
         }
         stmt.executeUpdate("CREATE TABLE t0054_1 (i INTEGER)");
         stmt.executeUpdate("INSERT INTO t0054_1 VALUES(1)");
         ResultSet rs = stmt.executeQuery("SELECT * FROM t0054_1");
         System.out.print("ResultSet: ");
         w = rs.getWarnings();
         if (w != null) 
         {
             System.out.println("Got Warning "+w.getMessage());
             passed = false;
         }
         rs.clearWarnings();
         rs.close();
         System.out.println((passed ? "Passed" : "Failed"));

         System.out.println("Now let's generate warnings");
         try 
         {
             stmt.executeUpdate("drop table t0054_2");
         } 
         catch (SQLException sqlEx) 
         {
         }
         if (stmt.getWarnings() != null) 
         {
            System.out.println("Got Warning "+stmt.getWarnings().getMessage());
            passed = false;
         }
         
         System.out.print("Table exceeding maximum rowsize: ");
         stmt.executeUpdate("CREATE TABLE t0054_2 ("
                            + "c01  VARCHAR(255), "
                            + "c02  VARCHAR(255), "
                            + "c03  VARCHAR(255), "
                            + "c04  VARCHAR(255), "
                            + "c05  VARCHAR(255), "
                            + "c06  VARCHAR(255), "
                            + "c07  VARCHAR(255), "
                            + "c08  VARCHAR(255), "
                            + "c09  VARCHAR(255), "
                            + "c10  VARCHAR(255), "
                            + "c11  VARCHAR(255), "
                            + "c12  VARCHAR(255), "
                            + "c13  VARCHAR(255), "
                            + "c14  VARCHAR(255), "
                            + "c15  VARCHAR(255), "
                            + "c16  VARCHAR(255), "
                            + "c17  VARCHAR(255), "
                            + "c18  VARCHAR(255), "
                            + "c19  VARCHAR(255), "
                            + "c20  VARCHAR(255), "
                            + "c21  VARCHAR(255), "
                            + "c22  VARCHAR(255), "
                            + "c23  VARCHAR(255), "
                            + "c24  VARCHAR(255), "
                            + "c25  VARCHAR(255), "
                            + "c26  VARCHAR(255), "
                            + "c27  VARCHAR(255), "
                            + "c28  VARCHAR(255), "
                            + "c29  VARCHAR(255), "
                            + "c30  VARCHAR(255), "
                            + "c31  VARCHAR(255), "
                            + "c32  VARCHAR(255), "
                            + "c33  VARCHAR(255), "
                            + "c34  VARCHAR(255), "
                            + "c35  VARCHAR(255), "
                            + "c36  VARCHAR(255), "
                            + "c37  VARCHAR(255), "
                            + "c38  VARCHAR(255), "
                            + "c39  VARCHAR(255), "
                            + "c40  VARCHAR(255), "
                            + "c41  VARCHAR(255), "
                            + "c42  VARCHAR(255), "
                            + "c43  VARCHAR(255), "
                            + "c44  VARCHAR(255), "
                            + "c45  VARCHAR(255), "
                            + "c46  VARCHAR(255), "
                            + "c47  VARCHAR(255), "
                            + "c48  VARCHAR(255), "
                            + "c49  VARCHAR(255), "
                            + "c50  VARCHAR(255), "
                            + "c51  VARCHAR(255), "
                            + "c52  VARCHAR(255), "
                            + "c53  VARCHAR(255), "
                            + "c54  VARCHAR(255), "
                            + "c55  VARCHAR(255), "
                            + "c56  VARCHAR(255), "
                            + "c57  VARCHAR(255), "
                            + "c58  VARCHAR(255), "
                            + "c59  VARCHAR(255), "
                            + "c60  VARCHAR(255), "
                            + "c61  VARCHAR(255), "
                            + "c62  VARCHAR(255), "
                            + "c63  VARCHAR(255), "
                            + "c64  VARCHAR(255), "
                            + "c65  VARCHAR(255), "
                            + "c66  VARCHAR(255), "
                            + "c67  VARCHAR(255), "
                            + "c68  VARCHAR(255), "
                            + "c69  VARCHAR(255), "
                            + "c70  VARCHAR(255), "
                            + "c71  VARCHAR(255), "
                            + "c72  VARCHAR(255), "
                            + "c73  VARCHAR(255), "
                            + "c74  VARCHAR(255), "
                            + "c75  VARCHAR(255), "
                            + "c76  VARCHAR(255), "
                            + "c77  VARCHAR(255), "
                            + "c78  VARCHAR(255), "
                            + "c79  VARCHAR(255), "
                            + "c80  VARCHAR(255), "
                            + "c81  VARCHAR(255), "
                            + "c82  VARCHAR(255), "
                            + "c83  VARCHAR(255), "
                            + "c84  VARCHAR(255), "
                            + "c85  VARCHAR(255), "
                            + "c86  VARCHAR(255), "
                            + "c87  VARCHAR(255), "
                            + "c88  VARCHAR(255), "
                            + "c89  VARCHAR(255), "
                            + "c90  VARCHAR(255), "
                            + "c91  VARCHAR(255), "
                            + "c92  VARCHAR(255), "
                            + "c93  VARCHAR(255), "
                            + "c94  VARCHAR(255), "
                            + "c95  VARCHAR(255), "
                            + "c96  VARCHAR(255), "
                            + "c97  VARCHAR(255), "
                            + "c98  VARCHAR(255), "
                            + "c99  VARCHAR(255)) ");
         // This generates a row size is too large warning on SQL Server 7,
         // don't know about others.
         if (stmt.getWarnings() == null) 
         {
            passed = false;
         }
         System.out.println((passed ? "Passed" : "Failed"));
         stmt.clearWarnings();
         if (stmt.getWarnings() != null) 
         {
            System.out.println("clearWarnings didn't work");
            passed = false;
         }
      }
      catch (SQLException e)
      {
         System.out.println(e.getMessage());
         e.printStackTrace();
         passed = false;
      }

      System.out.println("\n" + (passed ? "Passed" : "Failed") 
                         + " t0054.\n");
      System.exit(passed ? 0 : 1);
   }
}
